'use strict';
import {GameDeckMode} from '../../common/utils/const/game-deck-mode-enum';
import { PhaserScene } from '../../common/utils/const/phaser-scene-enum';
import Phaser from 'phaser';
import * as Utils from '../../common/utils/prompt-renderer';

export default class MainMenuScene extends Phaser.Scene {

  constructor(menuEventListener) {
    super({ key: PhaserScene.MAIN_MENU, active: false });
    this.menuEventListener = menuEventListener;

  }

  preload() {
    console.log('Preload');
    this.load.image('game-cover', '../../assets/twelveHeroes_cover.png');
    console.log("load main-menu.html");
    this.load.html('main-menu', '../../assets/html/main-menu.html');
  }

  create() {
    console.log('create');
    let background = this.add.image(400,300,'game-cover');
    //background.setOrigin(0,0);

    let element = this.add.dom(400, 600).createFromCache('main-menu');

    console.log(element);
    //element.setPerspective(800);

    element.addListener('click');

    element.on('click', function (event) {
      let eventName = event.target.name;

      switch (eventName) {
        case "loginButton":
          username=this.getChildByName('username');
          connectionStatus=this.getChildByName('connectionStatus');
          onlineGame=this.getChildByName('onlineGame');

          console.log(connectionStatus.value);
          console.log(onlineGame);
          break;
        case "onlineGame":

          break;
        case "localGame":

          break;

        default:
          break;
      }
    });

    this.tweens.add({
      targets: element,
      y: 300,
      duration: 3000,
      ease: 'Power3'
  });
    //this.add.dom



    // TODO : Display main menu
    // Create new scenes : Local player room / Multi player room
    // Pass to them the event listener
    // On local player room, user can enter player names, selected color, game deck mode & rules

    // FOR TESTING
    //this.fakeNewPnpGameSelected();
  }

  update() {

  }

  fakeNewPnpGameSelected() {
    setTimeout(() => {
      let pBlueName = prompt("Player blue name : ");
      let pRedName = prompt("Player red name : ");

      //let gameDeckModeOptions = Object.values(GameDeckMode);
      //let gameDeckMode = Utils.promptSelectAmongOptions("Select Deck Mode", gameDeckModeOptions);
      let gameDeckMode = "factions";
      let advancedRules = [];
      console.log("Calling listener");
      this.menuEventListener.onNewPnpGame(pBlueName, pRedName, gameDeckMode, advancedRules);
    }, 1000);
  }
}
